--[[
  MoveAnything! by Wagthaa<Savage Tribe> of Earthen Ring EU
  
  Based upon the ashes of:
		MoveAnything! V.2.66 by Vincent
		MoveAnything! vJ.11000.2 by Jason
		MA! 1.12 by Skrag

	Read the ReadMe
]]

local function Error( msg )
	maPrint( msg );--, 1.0, 0.2, 0.2
end

MovAny = {
	frameListSize = 13,
	bagFrames = {},
	initRun = false,	
	lastFrameName = nil,
	lSimpleHide = {
		MainMenuBarLeftEndCap = true,
		MainMenuBarRightEndCap = true,
	},
	lTranslate = {
		minimap = "MinimapCluster",
		tooltip = "TooltipMover",
		player = "PlayerFrame",
		target = "TargetFrame",
		pet = "PetFrame",
		focus = "FocusFrame",
		GameTooltip = "TooltipMover",
		BasicActionButtons = "BasicActionButtonsMover",
		PetActionButtons = "PetActionButtonsMover",
		ShapeshiftButtons = "ShapeshiftButtonsMover",
		BagButtons = "BagButtonsMover",
		MicroButtons = "MicroButtonsMover",
		Framerate = "FramerateMover",
		PaperDollFrame = "CharacterFrame",
		PetPaperDollFrame = "CharacterFrame",
		ReputationFrame = "CharacterFrame",
		SkillFrame = "CharacterFrame",
		CurrencyFrame = "CharacterFrame",
		FriendsListFrame = "FriendsFrame",
		RaidFrame = "FriendsFrame",
		WhoFrame = "FriendsFrame",
		ChannelFrame = "FriendsFrame",
		GuildFrame = "FriendsFrame",
		MainMenuBarBackpackButton = "BagButtonsMover",
		CharacterBag0Slot = "BagButtonsMover",
		CharacterBag1Slot = "BagButtonsMover",
		CharacterBag2Slot = "BagButtonsMover",
		CharacterBag3Slot = "BagButtonsMover",
		
		CharacterMicroButton = "MicroButtonsMover",
		SpellbookMicroButton = "MicroButtonsMover",
		TalentMicroButton = "MicroButtonsMover",
		AchievementMicroButton = "MicroButtonsMover",
		QuestLogMicroButton = "MicroButtonsMover",
		SocialsMicroButton = "MicroButtonsMover",
		PVPMicroButton = "MicroButtonsMover",
		LFGMicroButton = "MicroButtonsMover",
		WorldMapMicroButton = "MicroButtonsMover",
		MainMenuMicroButton = "MicroButtonsMover",
		HelpMicroButton = "MicroButtonsMover",
		
		PetActionButton1 = "PetActionButtonsMover",
		PetActionButton2 = "PetActionButtonsMover",
		PetActionButton3 = "PetActionButtonsMover",
		PetActionButton4 = "PetActionButtonsMover",
		PetActionButton5 = "PetActionButtonsMover",
		PetActionButton6 = "PetActionButtonsMover",
		PetActionButton7 = "PetActionButtonsMover",
		PetActionButton8 = "PetActionButtonsMover",
		PetActionButton9 = "PetActionButtonsMover",
		PetActionButton10 = "PetActionButtonsMover",
	},
	
	MOVEATONETIME = 20,
	SCROLL_HEIGHT = 25,
	FrameOptions = nil;
	Frames = {};
	CurrentMover = 1,
	NoScale = {
		TooltipMover = true,
		FramerateMover = true,
		MainMenuBarLeftEndCap = true,
		MainMenuBarRightEndCap = true,
		WorldStateAlwaysUpFrame = true,
		MainMenuBarArtFrame = true,
	},
	ScaleWH = {
		MainMenuExpBar = true,
		ChatFrameEditBox = true,
	},
	DetachFromParent = {
		MainMenuBarPerformanceBarFrame = true,
		TargetofFocusFrame = true,
		PetFrame = true,
		PartyMemberFrame1PetFrame = true,
		PartyMemberFrame2PetFrame = true,
		PartyMemberFrame3PetFrame = true,
		PartyMemberFrame4PetFrame = true,
		MainMenuBarLeftEndCap = true,
		MainMenuBarRightEndCap = true,
	},
	NoHide = { MAOptions = true },
	NoMove = { MinimapBorderTop = true, MainMenuBarArtFrame = true},
	HideList = {
		MainMenuBar = {
			{ "MainMenuBarArtFrame", "BACKGROUND","ARTWORK"},
			{ "PetActionBarFrame", "OVERLAY"},
			{ "ShapeshiftBarFrame", "OVERLAY"},
			{ "MainMenuBar", "DISABLEMOUSE"},
			{ "BonusActionBarFrame", "OVERLAY", "DISABLEMOUSE"},
			{ "MainMenuBarLeftEndCap", "FRAME"},
			{ "MainMenuBarRightEndCap", "FRAME"},
		},
		MainMenuExpBar = {
			{ "MainMenuExpBar", "WH", "BORDER", "OVERLAY"},
			{ "ExhaustionTick", "FRAME"},
			{ "MainMenuExpBar", function( show )
					if MovAny:SafeToMove() then	
						if( show ) then
							MovAny:AllowExternalVisibility( MainMenuExpBar.TextString );
						else
							MovAny:PreventExternalVisibility( MainMenuExpBar.TextString );
						end
					end
				end		
			},
		},
	},
	HideUsingWH = { MainMenuExpBar = true },
	MoveOnlyWhenVisible = {
	},
	DefaultFrameList = {
	
		{ "MAOptions", "MA! Window" },
	
		{ "Separator", "**** Standard Unit Frames ****" },
		{ "PlayerFrame", "Player" },
		{ "TargetFrame", "Target" },
		{ "TargetofTargetFrame", "Target of Target" },
		{ "FocusFrame", "Focus" },
		{ "TargetofFocusFrame", "Target of Focus" },
		{ "PartyMemberFrame1", "Party Member 1" },
		{ "PartyMemberFrame2", "Party Member 2" },
		{ "PartyMemberFrame3", "Party Member 3" },
		{ "PartyMemberFrame4", "Party Member 4" },
	
		{ "Separator", "**** Pets ****" },
		{ "PetFrame", "Pet" },
		{ "PartyMemberFrame1PetFrame", "Party Pet 1" },
		{ "PartyMemberFrame2PetFrame", "Party Pet 2" },
		{ "PartyMemberFrame3PetFrame", "Party Pet 3" },
		{ "PartyMemberFrame4PetFrame", "Party Pet 4" },
		
		{ "Separator", "**** Bags ****" },
		{ "BagFrame1", "Backpack" },
		{ "BagFrame2", "Bag 1" },
		{ "BagFrame3", "Bag 2" },
		{ "BagFrame4", "Bag 3" },
		{ "BagFrame5", "Bag 4" },
	
		{ "Separator", "**** Bank ****" },
		{ "BankFrame", "Bank Teller Window" },
		{ "BankBagFrame1", "Bank Bag 1" },
		{ "BankBagFrame2", "Bank Bag 2" },
		{ "BankBagFrame3", "Bank Bag 3" },
		{ "BankBagFrame4", "Bank Bag 4" },
		{ "BankBagFrame5", "Bank Bag 5" },
		{ "BankBagFrame6", "Bank Bag 6" },
		{ "BankBagFrame7", "Bank Bag 7" },
	
		{ "Separator", "**** Bottom Bar ****" },
		{ "MainMenuBar", "Bottom Bar" },
		{ "MainMenuBarLeftEndCap", "Left Gryphon" },
		{ "MainMenuBarRightEndCap", "Right Gryphon" },
		{ "MainMenuExpBar", "Experience Bar" },
	
		{ "Separator", "**** Action Button Bars ****" },
		{ "BasicActionButtonsMover", "Action Buttons" },
		{ "BasicActionButtonsVerticalMover", "Action Buttons (Vertical)" },
		{ "PetActionButtonsMover", "Pet Action Buttons" },
		{ "PetActionButtonsVerticalMover", "Pet Action Buttons (Vertical)" },
		{ "ShapeshiftButtonsMover", "Stance / Aura / Shapeshift Buttons" },
		{ "ShapeshiftButtonsVerticalMover", "Stance / Aura / Shapeshift (Vertical)" },
	
		{ "Separator", "**** Bag and Micro Button Bars ****" },
		{ "BagButtonsMover", "Bag Buttons" },
		{ "BagButtonsVerticalMover", "Bag Buttons (Vertical)" },
		{ "MicroButtonsMover", "Micro Buttons" },
		{ "MicroButtonsVerticalMover", "Micro Buttons (Vertical)" },
	
		{ "Separator", "**** Extra Action Bars ****" },
		{ "MultiBarBottomLeft", "Bottom Left ActionBar" },
		{ "MultiBarBottomRight", "Bottom Right ActionBar" },
		{ "MultiBarRight", "Right ActionBar" },
		{ "MultiBarLeft", "Right ActionBar 2" },
	
		{ "Separator", "**** Minimap ****" },
		{ "MinimapCluster", "MiniMap" },
		{ "MinimapZoneTextButton", "Zone Text" },
		{ "MinimapToggleButton", "Toggle Button (X)" },
		{ "MinimapBorderTop", "Minimap Top Border" },
		{ "MinimapZoomIn", "Zoom In Button" },
		{ "MinimapZoomOut", "Zoom Out Button" },
		{ "MiniMapMailFrame", "Mail Notification" },
		{ "MiniMapTracking", "Tracking" },
		{ "MiniMapBattlefieldFrame", "Battlefield" },
		{ "MiniMapWorldMapButton", "Map Button" },
		{ "GameTimeFrame", "Calendar Button" },
		{ "TimeManagerClockButton", "Clock" },
	
		{ "Separator", "**** Battle Grounds Elements ****" },
		{ "WorldStateAlwaysUpFrame", "Flags Frame"},
		{ "AlwaysUpFrame1", "Alliance Flag"},
		{ "AlwaysUpFrame2", "Horde Flag"},
		
		{ "Separator", "**** Loot Roll Frames ****" },
		{ "GroupLootFrame1", "Loot Roll Frame 1" },
		{ "GroupLootFrame2", "Loot Roll Frame 2" },
		{ "GroupLootFrame3", "Loot Roll Frame 3" },
		{ "GroupLootFrame4", "Loot Roll Frame 4" },
	
		{ "Separator", "**** Miscellaneous Screen Items ****" },
		{ "StaticPopup1", "Static Popup Frame" },
		{ "UIErrorsFrame", "UI Errors Frame" },
		{ "CastingBarFrame", "Casting Bar" },
		{ "BuffFrame", "Buff Window" },
		{ "TemporaryEnchantFrame", "Item buff/Debuff Windows" },
		{ "TooltipMover", "Tooltip" },
		{ "FramerateMover", "Framerate" },
		{ "DurabilityFrame", "Durability Damage Portrait" },
		{ "QuestWatchFrame", "Quest Tracker" },
		{ "QuestTimerFrame", "Quest Timer" },
		{ "AchievementWatchFrame", "Achievements Tracker" },
		{ "ComboFrame", "Rogue Combo point counter" },
		{ "MirrorTimer1", "Breath/Fatigue Bar" },
		{ "VoiceChatTalkers", "Voice Chat Talkers" },
		{ "ScriptErrors", "Script Errors" },
		{ "TutorialFrame", "Tutorial Frame" },
		{ "LootFrame", "Loot" },
		
		{ "Separator", "**** UI Windows ****" },
		{ "AchievementFrame", "Achievements" },
		{ "AuctionFrame", "Auction House" },
		{ "GuildBankFrame", "Guild Bank" },
	
		{ "Separator", "**** General Info Panel Placement ****" },
		{ "UIPanelMover1", "Info Panel 1" },
		{ "UIPanelMover2", "Info Panel 2" },
	
		{ "Separator", "**** Specific Info Panels ****" },
		{ "CharacterFrame", "Character / Pet / Reputation / Skills" },
		{ "PlayerTalentFrame", "Talents" },
		{ "TradeSkillFrame", "Trade Skills" },
		{ "InspectFrame", "Inspect" },
		{ "SpellBookFrame", "Spell Book" },
		{ "GossipFrame", "Gossip" },
		{ "TaxiFrame", "Flight Paths" },
		{ "QuestLogFrame", "Quest Log" },
		{ "QuestFrame", "Quest Proposal" },
		{ "MerchantFrame", "Merchant" },
		{ "BankFrame", "Bank" },
		{ "TradeFrame", "Trade" },
		{ "FriendsFrame", "Friends / Who / Guild / Chat / Raid" },
		{ "MacroFrame", "Macros" },
		{ "MailFrame", "Mailbox" },
		{ "OpenMailFrame", "Open Mail" },
		{ "TalentFrame", "Talent Tree" },
		{ "PetStableFrame", "Pet Stable" },
		
		{ "Separator", "**** Game Menu****" },
		{ "GameMenuFrame", "Game Menu" },
		{ "VideoOptionsFrame", "Video Options" },
		{ "AudioOptionsFrame", "Sound & Voice Options"},
		{ "InterfaceOptionsFrame", "Interface Options"},
		{ "KeyBindingFrame", "Keybinding Options" },
		{ "GameMenuButtonMoveAnything", "MA! Game Menu Button" },
		
		{ "Separator", "**** Zoning Text ****" },
		{ "ZoneTextFrame", "Zone Zoning Text" },
		{ "SubZoneTextFrame", "Subzone Zoning Text" },
		
		{ "Separator", "**** Custom Windows ****" }
	}
};

BINDING_HEADER_MOVEANYTHING = "MoveAnything!";
MA_LEFTARROW = "<";
MA_RIGHTARROW = ">";

MoveAnything_CustomFrames = {};
MoveAnything_CharacterSettings = {};
MoveAnything_UseCharacterSettings = false;

StaticPopupDialogs["MOVEANYTHING_RESET_CONFIRM"] = {
	text = "Reset all?",
	button1 = TEXT(YES),
	button2 = TEXT(NO),
	OnAccept = function()
		MovAny:ResetAll();
	end,
	timeout = 0,
	exclusive = 1,
	showAlert = 1
};

function MovAny:Boot()
	if self.initRun then
		return
	end
	
	local tmp = {};
	-- add default frames to list
	for i, v in pairs(self.DefaultFrameList) do
		if v[1]  then
			if v[1] == "Separator" then
				local sep = {}
				sep.name = nil
				sep.helpfulName = v[2]
				table.insert(self.Frames, sep)
				self.DefaultFrameList[i] = nil;
			else
				self:AddFrameToMovableList(v[1], v[2], true)
				self.DefaultFrameList[i] = v[2];
				tmp[ v[1] ] = true;
			end
		end
	end
	self.DefaultFrameList = tmp;
	tmp = nil;
	
	local settingsName = self:GetSettingsName()
	if MoveAnything_CharacterSettings[settingsName] == nil then
		MoveAnything_CharacterSettings[settingsName] = {}
	end
	self.FrameOptions = MoveAnything_CharacterSettings[settingsName]

	-- add custom frames to list
	for i, v in pairs(MoveAnything_CustomFrames) do
		if not self:FindFrame( v.name ) then
			self:AddFrameToMovableList(v.name, v.helpfulName, true)
		end
	end

	self.initRun = true;
	self:RefreshPositions();
end

function MovAny:ErrorNotInCombat(msg)
 maPrint("Not operational in combat", msg)
end

function MovAny:CheckErrorNotInCombat(msg)
	if UnitAffectingCombat("player") then
		self:ErrorNotInCombat(msg);
		return true
	end
	return false
end

function MovAny:ToggleVisibilityOnFrame(frame)
	if not frame then
		return;
	end
	local opt = self:GetFrameOptions( frame:GetName() );
	if opt and opt.hidden == true then
		self:ShowFrame(frame)
	else
		self:HideFrame(frame)
	end
end

function MovAny:IsScalableFrame( frameName )
	if( self.NoScale[ frameName ] or self.ScaleWH[ frameName ] ) then
		return false;
	end
	return true;
end

function MovAny:RefreshPositions()
	if not self.initRun or not self:SafeToMove() then
		return;
	end
	
	local frame, parent;
	for k, opt in pairs(self.FrameOptions) do
		if not self:IsMAFrame(opt.name) then
			frame = getglobal( opt.name )
			if( frame ) then
				if( opt.movable or opt.hidden ) then
					self:HookFrame( opt.name, frame );
				end
				if( opt.movable ) then
					if( self.DetachFromParent[ opt.name ] ) then
						parent = UIParent;
					else
						parent = MAGetParent( frame );
					end
					frame:HiddenClearAllPoints();
					frame:HiddenSetPoint( "BOTTOMLEFT", parent:GetName(), "BOTTOMLEFT", opt.x, opt.y );
					if( opt.scale ) then
						if frame.GetScale and frame:GetScale()~=opt.scale then
							frame:HiddenSetScale( opt.scale );
						end
						if( frame.attachedChildren ) then
							for i, v in pairs(frame.attachedChildren) do
								if v.GetScale and v:GetScale()~=opt.scale then
									v:HiddenSetScale( opt.scale );
								end
							end
						end
					end
				end
				if( opt.hidden ) then
					self:HideFrame( frame );
				end
			end
		end
	end
end

function MovAny:GetSettingsName(override)
	local val = MoveAnything_UseCharacterSettings
	if override ~= nil then
		val = override
	end
	if val then
		return GetCVar("realmName").." "..UnitName("player")
	else
		return "default"
	end
end

function MovAny:CopySettings( fromName, toName )
	if( MoveAnything_CharacterSettings[toName] == nil ) then
		MoveAnything_CharacterSettings[toName] = {};
	end
	for i, val in pairs(MoveAnything_CharacterSettings[fromName]) do
		MoveAnything_CharacterSettings[toName][i] = val;
	end
	self.FrameOptions = MoveAnything_CharacterSettings[self:GetSettingsName()];
	self:RefreshPositions();
end

function MovAny:GetFrameCount()
	return table.getn(self.Frames );
end

function MovAny:ClearFrameOptions( frameName )
	self.FrameOptions[frameName] = nil;
	self:RemoveIfCustom( frameName );
end

function MovAny:GetFrameOptions( frameName )
	if( self.FrameOptions == nil ) then
		return nil;
	end
	return self.FrameOptions[frameName];
end

function MovAny:GotFrameOptions(frameName)
	if self.FrameOptions[frameName] then
		return true
	end
	return false
end

function MovAny:FindFrame( frameName )
	for i in pairs(self.Frames) do
		if( self.Frames[i].name == frameName ) then
			return self.Frames[i];
		end
	end
	return nil;
end

function MovAny:RemoveIfCustom( frameName )
	local removed = false;
	for i in pairs(MoveAnything_CustomFrames) do
		if( MoveAnything_CustomFrames[i].name == frameName ) then
			table.remove( MoveAnything_CustomFrames, i );
			removed = true;
			break;
		end
	end
	if( removed ) then
		for i in pairs(self.Frames) do
			if( self.Frames[i].name == frameName ) then
				table.remove( self.Frames, i );
				break;
			end
		end
	end
end

function MovAny:PreventExternalVisibility( frame )
	if self.lSimpleHide[ frame ] then
		frame:Hide()
		return
	end

	frame.maWasShown = frame:IsShown()
	frame:Hide()
	frame.HiddenShow = frame.Show
	frame.HiddenHide = frame.Hide
	frame.HiddenIsVisible = frame.IsVisible
	frame.Show = MovAny_HiddenShow
	frame.Hide = MovAny_HiddenHide
	frame.IsVisible = MovAny_HiddenIsVisible
	if frame.attachedChildren then
		for i, val in pairs(frame.attachedChildren) do
			self:PreventExternalVisibility(val)
		end
	end
end

function MovAny:AllowExternalVisibility( frame )
	if self.lSimpleHide[ frame ] then
		frame:Show()
		return
	end
	
	frame.Show = frame.HiddenShow;
	frame.Hide = frame.HiddenHide;
	frame.IsVisible = frame.HiddenIsVisible;
	frame.HiddenShow = nil;
	frame.HiddenHide = nil;
	frame.HiddenIsVisible = nil;
	if frame.maWasShown then
		frame.maWasShown = nil
		frame:Show()
	end
	if frame.attachedChildren then
		for i, val in pairs(frame.attachedChildren) do
			self:AllowExternalVisibility(val)
		end
	end
end

function MovAny:PreventExternalMovement( frame )
	if self:SafeToMove() then
		if( frame.HiddenSetPoint == nil ) then
			frame.HiddenSetPoint = frame.SetPoint;
			frame.SetPoint = function() end;
		end
		if( frame.HiddenSetAllPoints == nil ) then
			frame.HiddenSetAllPoints = frame.SetAllPoints;
			frame.SetAllPoints = function() end;
		end
		if( frame.HiddenClearAllPoints == nil ) then
			frame.HiddenClearAllPoints = frame.ClearAllPoints;
			frame.ClearAllPoints = function() end;
		end
		if( frame.HiddenSetScale == nil ) then
			frame.HiddenSetScale = frame.SetScale;
			frame.SetScale = function() end;
		end
		if( frame.attachedChildren ) then
			for i, val in pairs(frame.attachedChildren) do
				self:PreventExternalMovement( val );
			end
		end
	else
		-- self:ErrorNotInCombat("MoveAnything_PreventExternalMovement")
	end		
end

function MovAny:AllowExternalMovement( frame )
	if self:SafeToMove() then
		if( frame.HiddenSetPoint ) then
			frame.SetPoint = frame.HiddenSetPoint;
			frame.HiddenSetPoint = nil;
		end
		if( frame.HiddenSetAllPoints ) then
			frame.SetAllPoints = frame.HiddenSetAllPoints;
			frame.HiddenSetAllPoints = nil;
		end
		if( frame.HiddenClearAllPoints ) then
			frame.ClearAllPoints = frame.HiddenClearAllPoints;
			frame.HiddenClearAllPoints = nil;
		end
		if( frame.HiddenSetScale ) then
			frame.SetScale = frame.HiddenSetScale;
			frame.HiddenSetScale = nil;
		end
		if( frame.attachedChildren ) then
			for i, val in pairs(frame.attachedChildren) do
				self:AllowExternalMovement( val );
			end
		end
	else
		-- self:ErrorNotInCombat("MoveAnything_AllowExternalMovement")
	end
end

function MovAny:HookFrame( frameName, frame )
	if not frame then
		frame = getglobal( frameName );
	end

	if( not self:IsFrameHooked( frameName ) ) then
		local opt = self:GetFrameOptions( frameName );
		if( opt == nil ) then
			opt = {};
			opt.movable = false;
			opt.hidden = false;
			self.FrameOptions[frameName] = opt;
		end
		opt.name = frameName;
		opt.originalLeft, opt.originalBottom = self:GetRelativeBottomLeft( frame );
		if( self.ScaleWH[ frameName ] ) then
			opt.originalWidth = frame:GetWidth();
			opt.originalHeight = frame:GetHeight();
			opt.originalScale = nil;
		else
			opt.originalWidth = nil;
			opt.originalHeight = nil;
			opt.originalScale = MAGetScale( frame );
		end
	end
	
	if( UIPanelWindows[frameName] ) then
		local left   = GetUIPanel("left");
		local center = GetUIPanel("center");

		if( frame == left ) then
			UIParent.left = nil;
			if( center ) then
				MovAny:SetLeftFrameLocation();
			end
		elseif( frame == center and left ) then
			UIParent.center = nil;
		end
		local opt = self:GetFrameOptions( frameName );
		if( opt ) then
			opt.UIPanelWindows = UIPanelWindows[frameName];
		end
		UIPanelWindows[frameName] = nil;
	end
	if( frame.OnMoveAnythingHook ) then
		frame.OnMoveAnythingHook( frame );
	end
	self:PreventExternalMovement( frame );
end

function MovAny:IsFrameHooked( frameName )
	if( frameName == nil ) then return; end
	local opt = self:GetFrameOptions( frameName );
	if( opt ) then
		if( opt.movable or opt.hidden ) then
			return true;
		end
	end
	return false;
end

function MovAny:IsFrameHidden( frameName )
	if( frameName == nil ) then return; end
	local opt = self:GetFrameOptions( frameName );
	if( opt ) then
		if( opt.hidden ) then
			return true;
		end
	end
	return false;
end

function MovAny:AddFrameToMovableList( frameName, helpfulName, isDefault )
	if( not self:FindFrame( frameName ) ) then
		local frame = getglobal( frameName );
		local listOptions = {};
		listOptions.name = frameName;
		listOptions.helpfulName = helpfulName;
		if( listOptions.helpfulName == nil ) then
			listOptions.helpfulName = listOptions.name;
		end
		table.insert( self.Frames, listOptions );
		-- if this is not a built-in default frame, we also need to add it to CustomFrames
		if( not isDefault ) then
			table.insert( MoveAnything_CustomFrames, listOptions );
		end
		self:UpdateGUIIfShown()
	end
end

function MovAny:Move(moveFrameName, helpfulName)
	if self:IsMAFrame(moveFrameName) then
		return
	end

	self.lastFrameName = moveFrameName

	if self.MoveOnlyWhenVisible[ moveFrameName ] then
		local frame = getglobal(moveFrameName)
		if frame == nil or not frame:IsShown() then
			Error("May only be moved when visible")
			return
		end
	end

	if not self:FindMAFrame(moveFrameName) then
		local frame = self:FindAvailableFrame()
		if frame == nil then
			Error("You can only move "..self.MOVEATONETIME.." frames at once.")
		elseif getglobal(moveFrameName) == nil then
			Error("\""..moveFrameName.."\" is not a valid frame name.")
		else
			local moveFrame = getglobal(moveFrameName)
			
			self:AddFrameToMovableList(moveFrameName, helpfulName)
			self:HookFrame(moveFrameName)
			self:Attach(frame,getglobal(moveFrameName))
			
			if moveFrame.OnMoveAnythingPostAttach then
				moveFrame.OnMoveAnythingPostAttach(moveFrame)
			end
			self:UpdateGUIIfShown()
		end
	end
end

function MovAny:GetTopFrameParentIfAny(f)
	local t = MovAny:Translate(f:GetName())
	if t ~= f:GetName() then
		return getglobal(t)
	end
	local c = f
	while c and c ~= UIParent do
		if c.GetName then
			local bag = string.match(c:GetName(),"^ContainerFrame[0-9]+")
			if bag then
				return getglobal(MovAny:Translate(self:GetBagInContainerFrame(bag)))
			end
			
			if self.DefaultFrameList[ c:GetName() ] then
				return getglobal(MovAny:Translate(c:GetName()))
			end
		end
		c = c:GetParent()
	end
	return f
end

function MovAny:MoveTopFrameUnderCursor()
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	obj = self:GetTopFrameParentIfAny(obj)
	if obj and obj ~= WorldFrame and obj ~= UIParent and obj.GetName then
		self:ToggleMove( obj:GetName() )
	end
	self:UpdateGUIIfShown()
end

function MovAny:HideTopFrameUnderCursor()
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	
	obj = self:GetTopFrameParentIfAny(obj)
	if obj and obj ~= WorldFrame and obj ~= UIParent then
		maPrint("Hiding frame: "..obj:GetName())
		self:AddFrameToMovableList(obj:GetName(), nil, false);
		self:HideFrame(obj)
	end
	self:UpdateGUIIfShown()
end

function MovAny:ResetFrameUnderCursor()
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	
	local frameName = obj:GetName()
	
	if MovAny:GotFrameOptions(frameName) then
		maPrint("Resetting frame: "..frameName)
		MovAny:ResetFrameOptions(frameName)
	else
		obj = self:GetTopFrameParentIfAny(obj)
		if obj and obj ~= WorldFrame and obj ~= UIParent then
			maPrint("Resetting frame: "..obj:GetName())
			MovAny:ResetFrameOptions(obj:GetName())
		end
	end
	self:UpdateGUIIfShown()
end

function MovAny:MoveFrameUnderCursor()
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	if obj and obj ~= WorldFrame and obj ~= UIParent and obj:GetName() then
		self:ToggleMove( obj:GetName() )
	end
	self:UpdateGUIIfShown()
end

function MovAny:HideFrameUnderCursor()
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	if obj and obj ~= WorldFrame and obj ~= UIParent then
		self:HideFrame(obj)
	end
	self:UpdateGUIIfShown()
end

function MovAny:UpdatePosition( moveFrame )
	local x, y, parent;
	x = nil;
	y = nil;
	parent = nil;
	if moveFrame.tagged  then
		if self.DetachFromParent[ moveFrame.tagged:GetName() ] then
			x = moveFrame.tagged:GetLeft();
			y = moveFrame.tagged:GetBottom();
			parent = UIParent;
		else
			x, y = self:GetRelativeBottomLeft(moveFrame.tagged);
			parent = MAGetParent(moveFrame.tagged);
		end
		local opt = self:GetFrameOptions(moveFrame.tagged:GetName());
		opt.x = x;
		opt.y = y;
	end
	return x, y, parent;
end

function MovAny:StopMoving( moveFrameName )
	local frame = self:FindMAFrame( moveFrameName );
	if( frame ) then
		self:Detach( frame );
		self:UpdateGUIIfShown()
	end
end

function MovAny:IsMover(frameName)
	if frameName ~= nil and string.match(frameName, "^MoveAnything[0-9][0-9]?$") ~= nil then
		return true
	else
		return false
	end
end

function MovAny:IsMAFrame(frameName)
	if frameName ~= nil and ( string.match(frameName, "^MoveAnything[0-9]+") ~= nil or frameName == "MAOptions" ) then
		return true
	else
		return false
	end
end

function MovAny:Translate(f)
	if self.lTranslate[ f ] then
		return self.lTranslate[ f ]
	else
		return f
	end
end

function MovAny:ToggleMove( moveFrameName )
	if self:IsMAFrame(MoveFrameName) then
		return
	end
	
	if string.match(moveFrameName, "^ContainerFrame[0-9]+$") then
		moveFrameName = self:GetBagInContainerFrame(moveFrameName)
	end
	
	if self:FindMAFrame( moveFrameName ) then
		self:StopMoving( moveFrameName )
	else
		self:Move( moveFrameName )
	end
end

function MovAny:FindMAFrame( moveFrameName )
	local frame;
	for i = 1, self.MOVEATONETIME, 1 do
		frame = getglobal( "MoveAnything"..i );
		if( type(frame) ~= "nil" and frame:IsShown() and frame.tagged == getglobal( moveFrameName ) ) then
			return frame;
		end
	end
	return nil;
end

function MovAny:FindAvailableFrame()
	local frame;
	for i = 1, self.MOVEATONETIME, 1 do
		frame = getglobal( "MoveAnything"..i );
		if( not( frame:IsShown() ) ) then
			return frame;
		end
	end
	return nil;
end

function MovAny:GetParentScaleRatio( frame )
	return MAGetScale( frame, 1 );
end

function MovAny:GetRelativeBottomLeft( tagFrame )
	x = tagFrame:GetLeft();
	if( x ) then
		x = x - MAGetParent( tagFrame ):GetLeft() * MAGetScale( MAGetParent( tagFrame ) ) / MAGetScale( tagFrame );
	end
	y = tagFrame:GetBottom();
	if( y ) then
		y = y - MAGetParent( tagFrame ):GetBottom() * MAGetScale( MAGetParent( tagFrame ) ) / MAGetScale( tagFrame );
	end
	return x,y;
end

function MovAny:Attach( moveFrame, tagFrame )
	if( moveFrame.tagged ) then
		self:Detach( moveFrame );
	end

	local listOptions = self:FindFrame( tagFrame:GetName() );
	local frameOptions = self:GetFrameOptions( tagFrame:GetName() );
	frameOptions.movable = true;
	moveFrame.helpfulName = listOptions.helpfulName;

	if( tagFrame.OnBeginMove ) then
		if( not tagFrame:OnBeginMove() ) then
			self:Detach( moveFrame );
			return;
		end
	end

	local x, y;
	x = 0
	y = 0
	if( tagFrame:GetLeft() == nil ) then tagFrame:Show(); tagFrame:Hide(); end
	
	if tagFrame:GetLeft() ~= nil then
	
	x = tagFrame:GetLeft() * MAGetScale( tagFrame, 1 ) / UIParent:GetScale();
	x = x - MAGetParent( tagFrame ):GetLeft() * MAGetScale( MAGetParent( tagFrame ), 1 ) / UIParent:GetScale();
	
	y = tagFrame:GetBottom() * MAGetScale( tagFrame, 1 ) / UIParent:GetScale();
	y = y - MAGetParent( tagFrame ):GetBottom() * MAGetScale( MAGetParent( tagFrame ), 1 ) / UIParent:GetScale();
	
	end
	
	moveFrame:ClearAllPoints();
	moveFrame:SetPoint( "BOTTOMLEFT", MAGetParent( tagFrame ):GetName(), "BOTTOMLEFT", x, y );
	
	moveFrame:SetWidth( tagFrame:GetWidth() * MAGetScale( tagFrame , 1 ) / UIParent:GetScale() );
	moveFrame:SetHeight( tagFrame:GetHeight() * MAGetScale( tagFrame, 1 ) / UIParent:GetScale() );
	
	if tagFrame.GetFrameLevel then
		moveFrame:SetFrameLevel( tagFrame:GetFrameLevel() + 1 );
	end
	
	tagFrame:HiddenClearAllPoints();
	tagFrame:HiddenSetPoint( "BOTTOMLEFT", moveFrame:GetName(), "BOTTOMLEFT", 0, 0 );

	moveFrame.tagged = tagFrame;

	moveFrame:Show();
end

function MovAny:Detach( moveFrame )
	if( moveFrame.tagged ) then
		local x, y, parent = self:UpdatePosition( moveFrame );
		moveFrame.tagged:HiddenClearAllPoints();
		moveFrame.tagged:HiddenSetPoint( "BOTTOMLEFT", parent:GetName(), "BOTTOMLEFT", x, y );
	end
	moveFrame:Hide();
	moveFrame.tagged = nil;
end

function MovAny:ResetFrameOptions( frameName )
	if frameName==nil then
			return
	end
	self:StopMoving(frameName)
	
	local frame = getglobal(frameName)
	if not frame then
		self:ClearFrameOptions( frameName )
		self:UpdateGUIIfShown()
		return
	end
	
	local opt = self:GetFrameOptions(frameName)
	
	if frame.OnMoveAnythingPreReset then
		frame.OnMoveAnythingPreReset(frame)
	end
	
	local wasHidden = false
	local left = nil
	local bottom = nil
	local hidden = false
	local width = nil
	local height = nil
	local scale = nil
	if opt then
		left = opt.originalLeft
		bottom = opt.originalBottom
		width = opt.originalWidth
		height = opt.originalHeight
		if opt.hidden then
			opt.hidden = false
			wasHidden = true
		end
		scale = opt.originalScale
	end
	
	self:AllowExternalMovement(frame)
	
	if wasHidden then
			self:ShowFrame(frame)
	end
	if left or bottom then
		frame:ClearAllPoints()
		frame:SetPoint( "BOTTOMLEFT", MAGetParent( frame ):GetName(), "BOTTOMLEFT", left, bottom )
	end
	if scale then
		if self:IsScalableFrame(frame:GetName()) and frame:GetScale()~=scale then
			frame:SetScale(scale)
		end
		if frame.attachedChildren then
		for i, v in pairs(frame.attachedChildren) do
			if self:IsScalableFrame(frame:GetName()) and v:GetScale()~=scale then
				v:SetScale(scale)
			end
		end
	end
	end
	if width then
		frame:SetWidth(width)
	end
	if height then
		frame:SetHeight(height)
	end
	
	if frame.OnMoveAnythingPostReset then
		frame.OnMoveAnythingPostReset(frame)
	end

	frame.attachedChildren = nil
	if opt and opt.UIPanelWindows then
		UIPanelWindows[ frameName ] = opt.UIPanelWindows
		if frame:IsShown() then
			frame:Hide()
			ShowUIPanel(frame)
		end
	end
	
	self:ClearFrameOptions(frameName)
	self:UpdateGUIIfShown()
end

function MovAny:ToggleOptionsMenu()
	if( MAOptions:IsShown() ) then
		MAOptions:Hide();
	else
		MAOptions:Show();
	end
end

function MovAny:GetIndex( frame )
	local index = tonumber( string.sub( frame:GetName(), string.len( "MAMove" ) + 1, -1 ) );
	return index + FauxScrollFrame_GetOffset( MAScrollFrame );
end

function MovAny:GetMovableFrame( optionsListFrame )
	local index = self:GetIndex( optionsListFrame );
	return getglobal( self.Frames[index].name );
end

function MovAny:OnMoveCheck( button )
	local frame = self:GetMovableFrame( MAGetParent( button ) );
	
	if ( frame == nil or ( self.MoveOnlyWhenVisible[ frame:GetName() ] and not frame:IsShown() ) ) then
		maPrint( "May only be moved when visible." );
		button:SetChecked(false);
		return;
	end
	
	local frameName = frame:GetName();
	
	if( button:GetChecked() ) then
		self:Move( frameName );
	else
		self:StopMoving( frameName );
	end
	
	self:UpdateGUIIfShown()
end

function MovAny:HideFrame( frame )
	if not frame then
		return
	end
	if self:IsMAFrame(frame:GetName()) then
		return false
	end
	if not self:IsFrameHooked(frame:GetName()) then
		self:HookFrame( frame:GetName() )
	end
	
	local opt = self:GetFrameOptions(frame:GetName())
	opt.hidden = true
	frame.maWasShown = frame:IsShown()
	
	if self.HideList[ frame:GetName() ] then
		for hIndex, hideEntry in pairs(self.HideList[ frame:GetName() ]) do
			local val = getglobal(hideEntry[1])
			local hideType
			for i = 2, table.getn(hideEntry) do
				hideType = hideEntry[ i ]
				if type(hideType) == "function" then
					hideType(false)
				elseif hideType == "DISABLEMOUSE" then
					val:EnableMouse(false)
				elseif hideType == "FRAME" then
					self:PreventExternalVisibility(val)
				elseif hideType == "WH" then
					self:StopMoving(frame:GetName())
					val:SetWidth(1)
					val:SetHeight(1)
				else
					val:DisableDrawLayer( hideType )
				end
			end
		end
	elseif self.HideUsingWH[ frame:GetName() ] then
		self:StopMoving(frame:GetName())
		frame:SetWidth(1)
		frame:SetHeight(1)
	else
		self:PreventExternalVisibility(frame)
	end
end

function MovAny:ShowFrame( frame )
	if ( not frame ) then return; end
	local opt = self:GetFrameOptions( frame:GetName() );
	
	if( opt and opt.hidden ) then
		if( not opt.movable ) then
			-- if being hidden is the only thing we're controlling with this frame
			-- do a full reset instead of a simple show
			self:ResetFrameOptions(frame:GetName())
			return;
		end
	end

	if( opt ) then
		opt.hidden = false;
	end
	if( self.HideList[ frame:GetName() ] ) then
		for hIndex, hideEntry in pairs(self.HideList[ frame:GetName() ]) do
			local val = getglobal( hideEntry[1] );
			local hideType;
			for i = 2, table.getn( hideEntry ) do
				hideType = hideEntry[i];
				if( type( hideType ) == "function" ) then
					hideType( true );
				elseif( hideType == "DISABLEMOUSE" ) then
					val:EnableMouse( true );
				elseif( hideType == "FRAME" ) then
					self:AllowExternalVisibility( val );
				elseif( hideType == "WH" ) then
					val:SetWidth( opt.originalWidth );
					val:SetHeight( opt.originalHeight );
				else
					val:EnableDrawLayer( hideType );
				end
			end
		end
	elseif( self.HideUsingWH[ frame:GetName() ] ) then
		frame:SetWidth( opt.originalWidth );
		frame:SetHeight( opt.originalHeight );
	else
		self:AllowExternalVisibility( frame );
	end
end

function MovAny:OnHideCheck( button )
	local frame = self:GetMovableFrame(MAGetParent(button))
	if not frame then
		return
	end
	if button:GetChecked() then
		self:HideFrame(frame)
	else
		self:ShowFrame(frame)
	end
	self:UpdateGUIIfShown()
end

function MovAny:OnResetCheck( button )
	local index = self:GetIndex(MAGetParent(button))
	self:ResetFrameOptions(self.Frames[index].name)
end

function MovAny:OnCheckCharacterSpecific( button )
	local oldName = self:GetSettingsName()
	if( button:GetChecked() ) then
		MoveAnything_UseCharacterSettings = true
		self:CopySettings(oldName, self:GetSettingsName())
	else
		MoveAnything_UseCharacterSettings = false
		self:CopySettings(oldName, self:GetSettingsName())
	end
	self:UpdateGUIIfShown()
end

function MovAny:SafeToMove()
	if UnitAffectingCombat("player") then
		return false
	else
		return true
	end
end

function MovAny:OnSizeChanged( obj )
	if( obj.tagged ) then
		local s, w, h, opt;

		opt = self:GetFrameOptions( obj.tagged:GetName() );

		if( self.ScaleWH[ obj.tagged:GetName() ] ) then
			obj.tagged:SetHeight( obj:GetHeight() );
			obj.tagged:SetWidth( obj:GetWidth() );
			-- if obj ever needs to apply to a frame with attached children,
			-- we're going to have to figure out what to do, since setting
			-- the W and H directly is definitely incorrect

			if( opt ) then
				opt.width = obj:GetHeight();
				opt.height = obj:GetHeight();
			end
		else
			if( obj.MASizingAnchor == "LEFT" or obj.MASizingAnchor == "RIGHT" ) then
				w = obj:GetWidth();
				h = w * (obj.tagged:GetHeight() / obj.tagged:GetWidth());
				if( h < 16 ) then
					h = 16;
					w = h * (obj.tagged:GetWidth() / obj.tagged:GetHeight());
				end
			else
				h = obj:GetHeight();
				w = h * (obj.tagged:GetWidth() / obj.tagged:GetHeight());
				if( w < 16 ) then
					w = 16;
					h = w * (obj.tagged:GetHeight() / obj.tagged:GetWidth());
				end
			end
			s = obj:GetWidth() / obj.tagged:GetWidth();
			s = s / MAGetScale( obj.tagged:GetParent(), 1  ) * UIParent:GetScale();

			if( self:IsScalableFrame( obj.tagged:GetName() ) ) then
				if( opt ) then
					opt.scale = s;
				end

				if obj.tagged.HiddenSetScale then
					obj.tagged:HiddenSetScale( s )
				end
				if( obj.tagged.attachedChildren ) then
					for i, v in pairs(obj.tagged.attachedChildren) do
						v:HiddenSetScale( s );
					end
				end
			end
			obj:SetWidth( w );
			obj:SetHeight( h );
		end
	end
end

function MovAny:UpdateGUIIfShown()
	if MAOptions and MAOptions:IsShown() then
		self:UpdateGUI();
	end
end

function MovAny:ResetAll()
	for i,v in pairs(self.FrameOptions) do
		self:ResetFrameOptions(v.name)
	end
	self.FrameOptions = {}
end

function MovAny:OnShow()
	ResizingNudger:Show()
	self:UpdateGUI()
end

function MovAny:OnHide()
	self:MoverOnHide()
end

function MovAny:UpdateGUI()
	FauxScrollFrame_Update(MAScrollFrame, MovAny:GetFrameCount(), MovAny.frameListSize, MovAny.SCROLL_HEIGHT );

	for i=1, MovAny.frameListSize, 1 do
		local index = FauxScrollFrame_GetOffset(MAScrollFrame) + i;
		if( index <= MovAny:GetFrameCount() ) then
		
			local f = getglobal( "MAMove"..i.."FrameNameText" );
			f:SetText( MovAny.Frames[index].helpfulName );
			if( MovAny.Frames[index] ) then
				getglobal( "MAMove"..i ):Show();
			end

			local frameName = MovAny.Frames[index].name;

			local opt = MovAny:GetFrameOptions( frameName );
			if( MovAny.Frames[index].name ) then
				getglobal( "MAMove"..i.."Backdrop" ):Show();
				getglobal( "MAMove"..i.."Move" ):Show();
			else
				getglobal( "MAMove"..i.."Backdrop" ):Hide();
				getglobal( "MAMove"..i.."Move" ):Hide();
			end

			if( MovAny:FindMAFrame( frameName ) ) then
				getglobal( "MAMove"..i.."Move" ):SetChecked( 1 );
			else
				getglobal( "MAMove"..i.."Move" ):SetChecked( nil );
			end
			if( opt and opt.hidden ) then
				getglobal( "MAMove"..i.."Hide" ):SetChecked( 1 );
			else
				getglobal( "MAMove"..i.."Hide" ):SetChecked( nil );
			end

			-- disallow hiding?
			if( not MovAny.Frames[index].name or MovAny.NoHide[ frameName ] ) then
				getglobal( "MAMove"..i.."Hide" ):Hide();
			else
				getglobal( "MAMove"..i.."Hide" ):Show();
			end

			-- disallow moving?
			if( not MovAny.Frames[index].name or MovAny.NoMove[ frameName ] ) then
				getglobal( "MAMove"..i.."Move" ):Hide();
			end

			-- add a reset button if it's movable
			if( MovAny:IsFrameHooked( frameName ) or frameIsCustom ) then
				getglobal( "MAMove"..i.."Reset" ):Show();
			else
				local frameIsCustom = false;
				for i,v in pairs(MoveAnything_CustomFrames) do
					if( v.name == frameName ) then
						frameIsCustom = true;
						break;
					end
				end
				if ( frameIsCustom ) then
					getglobal( "MAMove"..i.."Reset" ):Show();
				else
					getglobal( "MAMove"..i.."Reset" ):Hide();
				end
			end
		else
			getglobal( "MAMove"..i ):Hide();
		end

	end

	if( MoveAnything_UseCharacterSettings ) then
		MAOptionsCharacterSpecific:SetChecked( 1 );
	else
		MAOptionsCharacterSpecific:SetChecked( nil );
	end
end

function MovAny:GetContainerFrame( id )
	local i = 1;
	local container;
	while( 1 ) do
		container = getglobal( "ContainerFrame"..i );
		if( not container ) then break; end
		if( container:IsShown() and container:GetID() == id ) then
			return container;
		end
		i = i + 1;
	end
	return nil;
end

function MovAny:GetBagInContainerFrame( frameName )
	local frame = getglobal(frameName);
	if self.bagFrames[ frame:GetID() ] then
		return self.bagFrames[ frame:GetID() ]:GetName();
	end
	return nil
end

function MovAny:GrabContainerFrame( container, movableBag )
	if( movableBag and MovAny:IsFrameHooked( movableBag:GetName() ) ) then
		MovAny:PreventExternalMovement( container );
		container.MAContainerOriginalScale = MAGetScale( container );
		movableBag:Show();
		container:HiddenClearAllPoints();
		container:HiddenSetScale( MAGetScale( movableBag ) );
		--container:HiddenSetPoint( "BOTTOMLEFT", "UIParent", "BOTTOMLEFT", movableBag:GetLeft(), movableBag:GetBottom() );
		container:HiddenSetPoint( "BOTTOMLEFT", movableBag:GetName(), "BOTTOMLEFT", 0, 0 );
		movableBag.attachedChildren = {};
		table.insert( movableBag.attachedChildren, container );
	end
end

function MovAny:RemoveContainerFromList( container )
	local index = 1;
	local tempIndex;
	while ContainerFrame1.bags[index] do
		if ( ContainerFrame1.bags[index] == container:GetName() ) then
			ContainerFrame1.bagsShown = ContainerFrame1.bagsShown - 1;
			local tempIndex = index;
			while ContainerFrame1.bags[tempIndex] do
				if ( ContainerFrame1.bags[tempIndex + 1] ) then
					ContainerFrame1.bags[tempIndex] = ContainerFrame1.bags[tempIndex + 1];
				else
					ContainerFrame1.bags[tempIndex] = nil;
				end
				tempIndex = tempIndex + 1;
			end
		end
		index = index + 1;
	end
	updateContainerFrameAnchors();
end

function MovAny:Mover(dir)
	if ( dir > 0 ) then
		if ( self.CurrentMover < 20 ) then
			self.CurrentMover = self.CurrentMover + 1;
		else
			return;
		end
	else
		if ( MovAny.CurrentMover > 1 ) then
			self.CurrentMover = self.CurrentMover - 1;
		else
			return;
		end
	end
	self:NudgerFrameRefresh();
end

function MovAny:GetFirstMover()
	for i = 1, 20 do
		if ( getglobal("MoveAnything"..i):IsShown() ) then
			return i;
		end
	end
end

function MovAny:MoverOnShow(mover)
	ResizingNudger:Show();
	self.CurrentMover = tonumber(mover:GetID());
	self:NudgerFrameRefresh();
end

function MovAny:MoverOnHide()
	local firstMover = self:GetFirstMover();
	if ( firstMover ) then
		self.CurrentMover = firstMover;
		self:NudgerFrameRefresh();
	elseif ( MAOptions:IsShown() ) then
		self.CurrentMover = 1;
		self:NudgerFrameRefresh(1);
	else
		ResizingNudger:Hide();
	end
end

function MovAny:NudgerOnShow()
	self:NudgerFrameRefresh();
end

function MovAny:NudgerFrameRefresh(reset)
	if ( self.CurrentMover < 20 ) then
		ResizingNudger_MoverPlus:Enable();
	else
		ResizingNudger_MoverPlus:Disable();
	end
	if ( self.CurrentMover > 1 ) then
		ResizingNudger_MoverMinus:Enable();
	else
		ResizingNudger_MoverMinus:Disable();
	end

	local labelText = "MA "..self.CurrentMover.."/20";
	if ( not reset and getglobal("MoveAnything"..self.CurrentMover).tagged ) then
		labelText = labelText.."\n"..getglobal("MoveAnything"..self.CurrentMover).tagged:GetName();
	end
	ResizingNudgerTitle:SetText(labelText);
end

function MovAny:NudgerOnUpdate()
	-- This code is ripped from DiscordART :)
	local obj = GetMouseFocus();
	local text = "MouseOver: ";
	local label = ResizingNudgerMouseOver;

	if (obj and obj ~= WorldFrame and obj:GetName()) then
		text = text..obj:GetName();
		if (obj:GetParent()  and obj:GetParent() ~= WorldFrame and obj:GetParent():GetName() ) then
			text = text.."\nParent: "..obj:GetParent():GetName();
			if (obj:GetParent():GetParent() and obj:GetParent():GetParent() ~= WorldFrame and obj:GetParent():GetParent():GetName()) then
				text = text.."\nParent's Parent: "..obj:GetParent():GetParent():GetName();
			end
		end
	end

	if ( not string.find(text, "ResizingNudger") ) then
		label:SetText(text);
	else
		label:SetText("MouseOver: ");
	end
end

function MovAny:Center(lock)
	local mover = getglobal("MoveAnything"..self.CurrentMover);
	if ( lock == 0 ) then
		-- Both
		mover:ClearAllPoints();
		mover:SetPoint("CENTER",0,0);
	else
		local x, y;
		x = mover:GetLeft();
		y = mover:GetBottom();

		mover:ClearAllPoints();
		if ( lock == 1 ) then
			--Horizontal
			mover:SetPoint("CENTER",0,0);
			x = mover:GetLeft();
			mover:ClearAllPoints();
			mover:SetPoint("BOTTOMLEFT",x,y);
		elseif ( lock == 2 ) then
			-- Vertical
			mover:SetPoint("CENTER",0,0);
			y = mover:GetBottom();
			mover:ClearAllPoints();
			mover:SetPoint("BOTTOMLEFT",x,y);
		end
	end

	self:UpdatePosition(mover);
end

function MovAny:Nudge(dir, button)
	local x, y, offsetX, offsetY, parent, mover, offsetAmount;
	mover = getglobal("MoveAnything"..self.CurrentMover);

	if ( not mover:IsShown() ) then
		return;
	end

	x = mover:GetLeft();
	y = mover:GetBottom();

	if ( button == "RightButton" ) then
		if ( IsShiftKeyDown() ) then
			offsetAmount = 250;
		else
			offsetAmount = 50;
		end
	else
		if ( IsShiftKeyDown() ) then
			offsetAmount = 10;
		else
			offsetAmount = 1;
		end
	end

	if ( dir == 1 ) then
		offsetX = 0;
		offsetY = offsetAmount;
	elseif ( dir == 2 ) then
		offsetX = 0;
		offsetY = -offsetAmount;
	elseif ( dir == 3 ) then
		offsetX = -offsetAmount;
		offsetY = 0;
	elseif ( dir == 4 ) then
		offsetX = offsetAmount;
		offsetY = 0;
	end

	mover:ClearAllPoints();
	mover:SetPoint("BOTTOMLEFT","UIParent","BOTTOMLEFT",x + offsetX, y + offsetY);
	self:UpdatePosition(mover);
end

function MovAny:SizingAnchor( button )
	local s, e = string.find( button:GetName(), "Resize_" )
	local anchorto = string.sub( button:GetName(), e + 1 );
	local anchor;

	if( anchorto == "LEFT" ) then anchor = "RIGHT";
	elseif( anchorto == "RIGHT" ) then anchor = "LEFT";
	elseif( anchorto == "TOP" ) then anchor = "BOTTOM";
	elseif( anchorto == "BOTTOM" ) then anchor = "TOP";
	end
	return anchorto, anchor;
end

function MovAny:SetLeftFrameLocation()
	local left = GetUIPanel("left")
	if( left ) then
		if( self:IsFrameHooked( "UIPanelMover1" ) ) then
			left:ClearAllPoints()
			left:SetPoint( "TOPLEFT", "UIPanelMover1", "TOPLEFT", 0 )
			left:SetScale( MAGetScale( UIPanelMover1 ), 1 )
		else
			left:SetScale( 1 )
		end
	end
end

function MovAny:SetCenterFrameLocation()
	-- don't mess with the normal center panels, just the ones
	-- that are pushed over from the left
	if( GetUIPanel("left") ) then
		local center = GetUIPanel("center")
		if( center ) then
			if( self:IsFrameHooked( "UIPanelMover2" ) ) then
				center:ClearAllPoints()
				center:SetPoint( "TOPLEFT", "UIPanelMover2", "TOPLEFT" )
				center:SetScale( MAGetScale( UIPanelMover2 ), 1 )
			else
				center:SetScale( 1 )
			end
		end
	end
end

----------------------------------------------------------------

function MovAny_HiddenShow( obj )
	obj.maWasShown = true;
end

function MovAny_HiddenHide( obj )
	obj.maWasShown = false;
end

function MovAny_HiddenIsVisible( obj )
	return obj.maWasShown;
end

function MovAny_ListSettings( msg )
	maPrint( "Server/Character Settings List:", 1.0, 1.0, 0.2 );
	maPrint( "-------------------------------", 1.0, 1.0, 0.2 );
	for i, val in pairs(MoveAnything_CharacterSettings) do
		local str = i;
		if( val == MovAny.FrameOptions ) then
			str = str.." (Current)";
		end
		maPrint( str, 1.0, 1.0, 0.2 );
	end
end

----------------------------------------------------------------
-- X: hooks

function MovAny_ContainerFrame_GenerateFrame(frame, size, id)
	local bag = MovAny.bagFrames[ id ]
	MovAny:GrabContainerFrame(frame, bag)
end
hooksecurefunc("ContainerFrame_GenerateFrame", MovAny_ContainerFrame_GenerateFrame);

function MovAny_ContainerFrame_OnHide()
	local bag = MovAny.bagFrames[ this:GetID() ]
	if bag and MovAny:IsFrameHooked(bag:GetName()) then
		MovAny:AllowExternalMovement( this )
		if this.MAContainerOriginalScale then
			this:SetScale( this.MAContainerOriginalScale )
			this.MAContainerOriginalScale = nil
		end
		this:ClearAllPoints()
		-- we removed the container from the list before, but now we have to add
		-- it back, since the container code is going to try to remove it, and doesn't
		-- particularly care if it's already gone
		ContainerFrame1.bagsShown = ContainerFrame1.bagsShown + 1
		ContainerFrame1.bags[ ContainerFrame1.bagsShown ] = this:GetName()
	end
end
hooksecurefunc("ContainerFrame_OnHide", MovAny_ContainerFrame_OnHide);

function MovAny_ContainerFrame_OnShow(frame)
	local bag = MovAny.bagFrames[ frame:GetID() ]
	if bag and MovAny:IsFrameHooked(bag:GetName()) then
		MovAny:RemoveContainerFromList(frame)
	end
end
hooksecurefunc("ContainerFrame_OnShow", MovAny_ContainerFrame_OnShow);

function MovAny_CloseAllWindows(ignoreCenter)
	for i, v in pairs(MovAny.Frames) do
		if MovAny:IsFrameHooked( v.name ) then
			local opt = MovAny:GetFrameOptions( v.name)
			if opt and opt.UIPanelWindows then
				local f = getglobal(v.name)
				if ( f ~= nil ) then
					if( f:IsShown() ) then
						f:Hide()
					end
				end
			end
		end
	end
end
hooksecurefunc("CloseAllWindows", MovAny_CloseAllWindows)

function MovAny_ShowUIPanel(frame)
	if MovAny:SafeToMove() then
		MovAny:SetLeftFrameLocation()
		MovAny:SetCenterFrameLocation()
	end
end
hooksecurefunc("ShowUIPanel", MovAny_ShowUIPanel)

function MovAny_HideUIPanel(frame)
	if MovAny:SafeToMove() then
		MovAny:SetLeftFrameLocation()
		MovAny:SetCenterFrameLocation()
	end
end
hooksecurefunc("HideUIPanel", MovAny_HideUIPanel)

function MovAny_GameTooltip_SetDefaultAnchor(tooltip, parent)
	if tooltip == GameTooltip and MovAny:IsFrameHooked("TooltipMover") then
		-- anchor the tooltip to the side of the mover that is closest to the edge
		local l, r, t, b, a, anchor
		l = TooltipMover:GetLeft() - UIParent:GetLeft()
		r = UIParent:GetRight() - TooltipMover:GetRight()
		t = UIParent:GetTop() - TooltipMover:GetTop()
		b = TooltipMover:GetBottom() - UIParent:GetBottom()
		a = t
		anchor = "TOP"
		if( l < a ) then
			a = l
			anchor = "LEFT"
		end
		if( r < a ) then
			a = r
			anchor = "RIGHT"
		end
		if( b < a ) then
			a = b
			anchor = "BOTTOM"
		end

		tooltip:ClearAllPoints()
		tooltip:SetOwner(parent, "ANCHOR_NONE")
		tooltip:SetPoint(anchor, "TooltipMover", anchor, 0, 0)
		tooltip.default = 1
	end
end
hooksecurefunc("GameTooltip_SetDefaultAnchor", MovAny_GameTooltip_SetDefaultAnchor)

function MovAny_UpdateTalentButton(...)
	if MovAny:IsFrameHooked("MicroButtonsVerticalMover") then
		if UnitLevel("player") < 10 then
			AchievementMicroButton:SetPoint("TOPLEFT", "TalentMicroButton", "TOPLEFT", 0, 0)
		else
			AchievementMicroButton:SetPoint("TOPLEFT", "TalentMicroButton", "BOTTOMLEFT", 0, 24)
		end
	end
end
hooksecurefunc("UpdateTalentButton", MovAny_UpdateTalentButton)

----------------------------------------------------------------
-- X: slash commands

SLASH_MOVEANYTHING1 = "/move"
SlashCmdList["MOVEANYTHING"] = function( msg )

	if MovAny:SafeToMove() then
		if msg == nil or string.len( msg ) == 0 then
			MovAny:ToggleOptionsMenu()
		else
			MovAny:ToggleMove(MovAny:Translate(msg))
		end
	else
		MovAny:ErrorNotInCombat()
	end
end

SLASH_UNMOVEANYTHING1 = "/unmove"
SlashCmdList["UNMOVEANYTHING"] = function( msg )
	if msg then
		if MovAny:GotFrameOptions(msg) then
			MovAny:ResetFrameOptions(msg)
		else
			MovAny:ResetFrameOptions(MovAny:Translate(msg))
		end
	else
		Error("Syntax: /unmove framename")
	end
end

SLASH_MOVEANYTHINGCOPYSETTINGS1 = "/movecopy"
SlashCmdList["MOVEANYTHINGCOPYSETTINGS"] = function( msg )
	if( msg == nil or string.len( msg ) == 0 ) then
		Error( "Syntax: /movecopy ServerName PlayerName" )
		MovAny_ListSettings()
		return;
	end

	if( MoveAnything_CharacterSettings[msg] == nil ) then
		Error( "No settings for server/character "..msg )
		MovAny_ListSettings()
		return;
	end

	MovAny:CopySettings( msg, MovAny:GetSettingsName() )
end


SLASH_MOVEANYTHINGLISTSETTINGS1 = "/movelist"
SlashCmdList["MOVEANYTHINGLISTSETTINGS"] = MovAny_ListSettings

SLASH_MOVEANYTHINGDELETESETTINGS1 = "/movedelete"
SLASH_MOVEANYTHINGDELETESETTINGS2 = "/movedel"
SlashCmdList["MOVEANYTHINGDELETESETTINGS"] = function( msg )
	if( msg == nil or string.len( msg ) == 0 ) then
		Error( "Syntax: /movedelete ServerName PlayerName" );
		MovAny_ListSettings()
		return
	end

	if( MoveAnything_CharacterSettings[msg] == nil ) then
		Error( "No settings for server/character "..msg )
		MovAny_ListSettings()
		return;
	end

	if( msg == MovAny:GetSettingsName() ) then
		MovAny:ResetAll();
	else
		MoveAnything_CharacterSettings[msg] = nil;
	end
	MovAny.FrameOptions = MoveAnything_CharacterSettings[MovAny:GetSettingsName()];
	MovAny:RefreshPositions();
end

----------------------------------------------------------------
-- X: global functions

if not table.find then
	function table.find( table, value )
		for i, v in pairs(table) do
			if( v == value ) then
				return i;
			end
		end
		return nil;
	end
end

function MoveAnythingUpdater_OnUpdate(arg1)
	if MoveAnythingUpdater:GetScale() == UIParent:GetScale() then
		MoveAnythingUpdater:SetScale(0.2)
		MovAny:RefreshPositions()
	end
end

function MAGetParent( frame )
	if ( not frame or not frame.GetParent ) then return; end
	if( frame:GetParent() == nil ) then
		return UIParent;
	end

	return frame:GetParent();
end

function MAGetScale( frame, effective )
	if not frame or MovAny.NoMove[frame:GetName()] then
		return 1;
	else
		if( not frame.GetScale or frame:GetScale() == nil ) then
			return 1;
		end
	
		if ( effective ) then
			return frame:GetEffectiveScale();
		else
			return frame:GetScale();
		end
	end
end

function maPrint( msgKey, msgHighlight, msgAdditional, r, g, b, frame )
    local msgOutput 
    if ( frame ) then
    	msgOutput = frame
    else
    	msgOutput = DEFAULT_CHAT_FRAME;
    end
    
    if msgKey				 == "" then return; end;
    if msgKey        == nil then msgKey = "<nomsg>"; end;    
    if msgHighlight  == nil or msgHighlight  == "" then msgHighlight  = " "; end;
    if msgAdditional == nil or msgAdditional == "" then msgAdditional = " "; end;
    if( msgOutput ) then
        msgOutput:AddMessage( "|caaff0000MoveAnything|r|caaffff00>|r "..msgKey.." |caaaaddff"..msgHighlight.."|r"..msgAdditional, r, g, b );
    end
end;